using System;
using System.Drawing;
using System.Windows.Forms;
using System.Diagnostics;
using System.IO;
using System.Threading;
using WebFlow;

namespace Traffic
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private	TrafficInfo             oTrafficInfo	= new TrafficInfo();
		private	string		            strWorkDir		= Environment.CurrentDirectory;
        private const string            strFTPServer    = "webflow.wsdot.wa.gov";
        private const string            strBaseURL      = "http://images.wsdot.wa.gov/nwflow/wireless/";
        private const bool              fGetFTP         = true;

        #region Default Wizard Code

        private System.Windows.Forms.PictureBox pictureBox1;
        private System.Windows.Forms.Button buttonProcessData;
        private System.Windows.Forms.Button buttonGetBMP;
        private System.Windows.Forms.CheckBox checkBoxRepeat;
        private System.Windows.Forms.CheckBox checkBoxOnline;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.buttonProcessData = new System.Windows.Forms.Button();
            this.pictureBox1 = new System.Windows.Forms.PictureBox();
            this.buttonGetBMP = new System.Windows.Forms.Button();
            this.checkBoxRepeat = new System.Windows.Forms.CheckBox();
            this.checkBoxOnline = new System.Windows.Forms.CheckBox();
            this.SuspendLayout();
            // 
            // buttonProcessData
            // 
            this.buttonProcessData.Location = new System.Drawing.Point(152, 8);
            this.buttonProcessData.Name = "buttonProcessData";
            this.buttonProcessData.Size = new System.Drawing.Size(96, 23);
            this.buttonProcessData.TabIndex = 3;
            this.buttonProcessData.Text = "Process &Data";
            this.buttonProcessData.Click += new System.EventHandler(this.buttonProcessData_Click);
            // 
            // pictureBox1
            // 
            this.pictureBox1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.pictureBox1.Location = new System.Drawing.Point(8, 40);
            this.pictureBox1.Name = "pictureBox1";
            this.pictureBox1.Size = new System.Drawing.Size(312, 104);
            this.pictureBox1.TabIndex = 3;
            this.pictureBox1.TabStop = false;
            // 
            // buttonGetBMP
            // 
            this.buttonGetBMP.Location = new System.Drawing.Point(72, 8);
            this.buttonGetBMP.Name = "buttonGetBMP";
            this.buttonGetBMP.TabIndex = 2;
            this.buttonGetBMP.Text = "Get &BMP";
            this.buttonGetBMP.Click += new System.EventHandler(this.buttonGetBMP_Click);
            // 
            // checkBoxRepeat
            // 
            this.checkBoxRepeat.Enabled = false;
            this.checkBoxRepeat.Location = new System.Drawing.Point(256, 8);
            this.checkBoxRepeat.Name = "checkBoxRepeat";
            this.checkBoxRepeat.Size = new System.Drawing.Size(64, 24);
            this.checkBoxRepeat.TabIndex = 4;
            this.checkBoxRepeat.Text = "Repeat";
            // 
            // checkBoxOnline
            // 
            this.checkBoxOnline.Location = new System.Drawing.Point(8, 8);
            this.checkBoxOnline.Name = "checkBoxOnline";
            this.checkBoxOnline.Size = new System.Drawing.Size(64, 24);
            this.checkBoxOnline.TabIndex = 1;
            this.checkBoxOnline.Text = "&Online";
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(328, 152);
            this.Controls.Add(this.checkBoxOnline);
            this.Controls.Add(this.checkBoxRepeat);
            this.Controls.Add(this.buttonGetBMP);
            this.Controls.Add(this.buttonProcessData);
            this.Controls.Add(this.pictureBox1);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.Name = "Form1";
            this.Text = "Form1";
            this.Paint += new System.Windows.Forms.PaintEventHandler(this.Form1_Paint);
            this.ResumeLayout(false);

        }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

        #endregion Default Wizard Code

        private void Form1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
        {
            int i;

            pictureBox1.Update();

            Graphics g = pictureBox1.CreateGraphics();
            SolidBrush oBrush;

            Trace.WriteLine("Painting stations...");
            for(i=0; i < oTrafficInfo.oStations.Count; i++)
            {
                StationInfo oStation = (StationInfo)oTrafficInfo.oStations[i];

                int iX = oStation.iX;
                int iY = oStation.iY;
                Point[] oPoints = oStation.oPoints;
                Color oColor = oStation.colorCongestion;

                oBrush = new SolidBrush(oColor);

                try
                {
                    g.FillPolygon(oBrush, oPoints);
                }
                catch(Exception x)
                {
                    Trace.WriteLine("ERROR: Form1_Paint " + x.Message);
                }
            }

            if (i > 0 && i == oTrafficInfo.oStations.Count)
            {
                Font oFont = new Font(FontFamily.GenericSansSerif, 10, FontStyle.Bold | FontStyle.Italic);
                oBrush = new SolidBrush(Color.Black);
                Point oPoint = new Point(pictureBox1.Width - 175, 0);
                string strText = "Last Updated:\r\n" + DateTime.Now;
                g.DrawString(strText, oFont, oBrush, oPoint);
            }
        }

        private void buttonGetBMP_Click(object sender, System.EventArgs e)
        {
            Trace.WriteLine("buttonGetBMP_Click");

            bool fSuccess = false;

            if (checkBoxOnline.Checked)
            {
                if (fGetFTP)
                {

                    fSuccess = oTrafficInfo.GetFTPTrafficView(strFTPServer, strWorkDir);
                }
                else
                {
                    fSuccess = oTrafficInfo.GetWebTrafficBMP(strBaseURL, strWorkDir);
                    fSuccess = oTrafficInfo.GetWebTrafficSTA(strBaseURL, strWorkDir);
                    fSuccess = oTrafficInfo.GetWebTrafficXY(strBaseURL, strWorkDir);
                }
            }

            string strBMPFile = strWorkDir + "\\" + TrafficInfo.strWebFlowBMP;

            if (File.Exists(strBMPFile))
            {
                Image oBMPImage = Image.FromFile(strBMPFile);
                int iBMPHeight = oBMPImage.Height;
                int iBMPWidth = oBMPImage.Width;

                Height = Height - pictureBox1.Height + iBMPHeight;
                Width = Width - pictureBox1.Width + iBMPWidth;

                pictureBox1.Height = iBMPHeight;
                pictureBox1.Width = iBMPWidth;
                pictureBox1.Image = oBMPImage;
            }
        }

        private void buttonProcessData_Click(object sender, System.EventArgs e)
        {
            Trace.WriteLine("buttonProcessData_Click");

            bool fSuccess = false;

            if (checkBoxOnline.Checked)
            {
                if (fGetFTP)
                {
                    fSuccess = oTrafficInfo.GetFTPTrafficData(strFTPServer, strWorkDir);
                }
                else
                {
                    fSuccess = oTrafficInfo.GetWebTrafficDAT(strBaseURL, strWorkDir);
                    fSuccess = oTrafficInfo.GetWebTrafficMSG(strBaseURL, strWorkDir);
                }
            }

            fSuccess = oTrafficInfo.ProcessStationInfo(strWorkDir);

            this.Invalidate(true);
        }
    }
}
